? " DemoMain.sc"
@ Row(),13 ?? Fill("",28)
@ Row(),13
libname.a = "DDemo"
IF not IsFile(libname.a + ".Lib") then
    Createlib libname.a SIZE 60
ENDIF
; ===========================================================================
;       TITLE: LocateDemo.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01/29/91 05:13pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC LocateDemo.u()
Private proc.a, source.a, sens.a
proc.a = "LocateDemo.u"
   SetSwap swap.n
   ClearAll
   View "D\\Dandemo"
   Canvas ON
   WHILE true
      Wait TABLE Prompt
   " Demonstrating the Locate Menu...    Use [Ctrl+Z] to call Locate Menu",
   " Press [F2] or [Esc] when Finished"
      Until "FieldView", "F35", "Dos", "DosBig", "Rotate", "LockKey",
            "KeyLookup", "ZoomNext", "Zoom", "F1", "F2", "Esc", -35
      SWITCH
         CASE retval = -35    : HelpMenu.u("Locate")        ; Alt+H
         CASE retval = "F1"   : LookupHelpKey.u("Locate")
         CASE retval = "F2"
           OR retval = "Esc"  : Return
         CASE retval = "ZoomNext"
           OR retval = "Zoom" : LocateMenu.l()
         OTHERWISE            : Beep
      ENDSWITCH
   ENDWHILE
ENDPROC
WriteLib libname.a   LocateDemo.u
Release PROCS        LocateDemo.u
?? ""
; ===========================================================================
;       TITLE: SelectFormPick.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:39:06am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC SelectFormPick.u()
Private  select.r,                     ; Array for selected record
         proc.a                        ; Identifies proc to errorproc

   proc.a = "SelectFormPick.u"
   SetSwap swap.n
   ClearAll
   Message.u("This demonstrates selecting a Record from a form for processing",
              0,0)                     ; Calls message proc with "WORKING"
   Select.l("d\\dandemo",              ; Table name to select from
           (2+form.n),                 ; Form to use for selecting
            false,                     ; Form to use to Add, or false
           "0000",                     ; No Smartkey used
            false,                     ; Is help enabled?
           " Selecting Record to Print...    Press [Ctrl+Z] to Search for a Value",
           " Press [F2] to Select                                 [Esc] to Cancel")
   IF NOT retval THEN                  ; [Esc] was pressed in Select proc
      Message.u("C",0,0)
      Return
   ENDIF

   Message.u("W",0,0)
   Create "Entry" LIKE "d\\dandemo"    ; Using temporary table that is
   Edit "Entry"                        ;   erased at end of session.
   CopyFromArray select.r              ; Insert record selected earlier
   Do_It!                              ; Save record in answer table
   CopyReport "d\\dandemo" "1"         ; Copy report to use from Dandemo
              "Entry" "R"              ;   to temporary table

   PrintFile.u("Entry","R",pica.a,     ; Place report in file to browse
               "Demorpt.sc",false)     ;   and/or print.  I use ".sc" to make
                                       ;   it easier to delete the file (as a
                                       ;   script instead of a RUN command.
   PrintSelect.u("Demorpt.sc",port.a,  ; Name of report file
                  false,false,false)
   Message.u("M",0,0)
   Return
ENDPROC
WriteLib libname.a SelectFormPick.u
Release PROCS      SelectFormPick.u
?? ""
; ===========================================================================
;       TITLE: SelectIns_Pick.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:39:23am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC SelectIns_Pick.u()
Private select.r,                      ; Array for selected record
        dest.a,                        ; Destination for report
        file.a,                        ; File name for report saved to file
        proc.a                         ; Identifies proc to errorproc

   Message.u("This demonstrates ability to add a new record with a Smartkey Index",3,3)
   proc.a = "SelectIns_Pick.u"
   SetSwap swap.n
   ClearAll
   Select.l("d\\dandemo",              ; Table name to select from
           (2+form.n),                ; Form to use for selecting
           (4+form.n),                ; Form to use to Add, or false
           "8340",                    ; Smartkey Parameters used for Insert
            false,                    ; Is help enabled?
           " Selecting Record to Print...    Press [Ctrl+Z] to Search for a Value",
           " Press [F2] to Select     [Ins] to Add New record     [Esc] to Cancel")

   IF NOT retval THEN                  ; [Esc] was pressed in Select proc
      Message.u("C",0,0)
      Return
   ENDIF

   Message.u("W",0,0)
   Create "Entry" LIKE "d\\dandemo"    ; Using temporary table that is
   Edit "Entry"                        ;   erased at end of session.
   CopyFromArray select.r              ; Insert record selected earlier
   Do_It!                              ; Save record in answer table
   CopyReport "d\\dandemo" "1"         ; Copy report to use from Dandemo
              "Entry" "R"              ;   to temporary table

   PrintFile.u("Entry","R",pica.a,     ; Place report in file to browse
               "Demorpt.sc",false)     ;   and/or print.  I use ".sc" to make
                                       ;   it easier to delete the file (as a
                                       ;   script instead of a RUN command.
   PrintSelect.u("Demorpt.sc",port.a,  ; Name of report file
                  false,false,false)
   Message.u("M",0,0)
   Return
ENDPROC
WriteLib libname.a SelectIns_Pick.u
Release PROCS      SelectIns_Pick.u
?? ""
; ===========================================================================
;       TITLE: SelectArrayPick.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:39:40am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC SelectArrayPick.u()
Private  proc.a                           ; Name of current procedure
proc.a = "SelectArrayPick.u"
   SetSwap swap.n
   ClearAll
   CoEdit "d\\dandemo"
   PickForm 3 + form.n
   ImageRights UPDATE
   WHILE true
      Wait TABLE Prompt
" Demonstrating Array-based Picklist...    Press [F1] in [Category] for Lookup",
" Press [F2]-Save"
      Until "Dos", "DosBig", "Rotate", "FieldView", "F35", "Zoom", "ZoomNext",
            "Ins", "Del", "F1", "Esc", "F2", -35
      SWITCH
         CASE retval = "Zoom" : Zoom.l("FIRST")
         CASE retval = "ZoomNext" : Zoom.l("NEXT")
         CASE retval = "F2"
           OR retval = "Esc"  :
            Do_It!
            Message.u("M",0,0)
            Return
         CASE Field() = "Category"
          AND retval = "F1"   :
            LookupArray.v("l\\dandemol","Category")
            IF NOT retval = false THEN
               ImageRights
               [Category] = retval
               ImageRights READONLY
            ENDIF
         CASE retval = -35    : HelpMenu.u("Select")         ; Alt+H
         CASE retval = "F1"   : LookupHelpKey.u("Select")
         OTHERWISE            :  Beep
      ENDSWITCH
   ENDWHILE
ENDPROC
WriteLib libname.a SelectArrayPick.u
Release PROCS      SelectArrayPick.u
?? ""
; ===========================================================================
;       TITLE: SelectPopupForm.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:39:57am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC SelectPopupForm.u()
Private  proc.a                           ; Name of current procedure
   proc.a = "SelectPopupForm.u"
   Message.u("W",0,0)                      ; "Working" message, no beep, no sleep
   proc.a = "DemoLookup.u"                 ; Name passed to error proc
      SetSwap swap.n
      ClearAll
   CoEdit "d\\dandemo"                        ; Prefer CoEdit to Edit for speed
   ImageRights UPDATE                      ; Don't change key fields
   PickForm 1 + form.n
   WHILE true                              ; Loop 'til we droop
      Wait TABLE Prompt                   ; Wait for keypress of specified keys
" Demonstrating Pop-up Lookup Help...    Press [F1] while on Category Field",
" Press [F2] to Save and Return"
      Until "Dos", "DosBig", "Rotate", "FieldView", "F35", "Zoom", "ZoomNext",
            "Ins", "Del", "F1", "Esc", "F2", -35,
            "Up", "Down", "PgUp", "PgDn", "Right", "Left", "Enter", "Tab",
            "ReverseTab"

      SWITCH
         CASE retval = "PgDn"            ; We don't want to land on Page 2 of
           OR retval = "Down"            ;   this form (the popup form).  These
           OR retval = "Right"           ;   CASE statements check for this.
           OR retval = "Tab"             ;   You can adjust this for the # of
           OR retval = "Enter"   :       ;   legitmate pages in your form.
            KeyPress retval              ; Press key and see what happens
            IF PageNo() <> 1 THEN        ; We also don't want to be able to add
               IF NOT AtLast() THEN      ;   new records by moving beyond EOT
                  WHILE PageNo() <> 1
                     PgDn                ; If not on Page 1, keep going
                  ENDWHILE
               ELSE
                  PgUp Beep              ; Beep for last record
               ENDIF
            ENDIF
         CASE retval = "PgUp"            ; We don't want to land on Page 2 of
           OR retval = "Up"              ;   this form.  These CASE statements
           OR retval = "ReverseTab"      ;   check for this.
           OR retval = "Left"    :
            KeyPress retval              ; Press key and see what happens
            WHILE PageNo() <> 1
               PgUp                      ; If not on Page 1, keep going
            ENDWHILE
         CASE retval = "F1"  :           ; Use Switch in case other fields have help
            SWITCH
               CASE Field() = "Category" :
                                          ; Custom Lookup help for this field
                  LookupAddForm.u("l\\Dandemol","Category",true)
               OTHERWISE                   :
                  HelpMenu.u("Lookup")    ; Default help
            ENDSWITCH
         CASE retval = -35          : HelpMenu.u("Select")   ; Alt+H
         CASE retval = "Zoom"       : Zoom.l("FIRST")
         CASE retval = "ZoomNext"   : Zoom.l("NEXT")
         CASE retval = "FieldView"       ; Custom fieldview
            OR retval = "F35"    : FieldView.u()
         CASE retval = "F2"      :           ; All done
            Do_It!
            Message.u("M",0,0)
            Return
         OTHERWISE           : Beep      ; Illegal keypress
      ENDSWITCH
   ENDWHILE
ENDPROC
WriteLib libname.a SelectPopupForm.u
Release PROCS      SelectPopupForm.u
?? ""
; ===========================================================================
;       TITLE: Get_InputAccept.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:42:35am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC Get_InputAccept.u()
Private  proc.a                           ; Name of current procedure
proc.a = "Get_InputAccept.u"
   SetSwap swap.n
   Message.u("This routine demonstrates GetInput procedure without validation",0,3)
   d1 = GetInput.v(8,
                  "Enter a Date for this Demonstration",
                  "D",                ; Data type
                  "")                 ; Validation string (none)
   IF NOT d1 = false THEN              ; [Esc] not entered
      PopBox.u(18,"You Entered the Date: " + StrVal(d1),1,94,3)
   ENDIF
   Message.u("M",0,0)
   Clear Return
ENDPROC
WriteLib libname.a Get_InputAccept.u
Release PROCS      Get_InputAccept.u
?? ""
; ===========================================================================
;       TITLE: Get_InputValidate.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:42:42am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC Get_InputValidate.u()
Private  proc.a                           ; Name of current procedure
proc.a = "Get_InputValidate.u"
   SetSwap swap.n
   Message.u("This routine demonstrates GetInput procedure with validation",0,3)
   d2 = GetInput.v(8,
                  "Press [Enter] to Accept, or Enter New Date",
                  "D",                ; Data type
                  "DEFAULT 7/21/69")  ; Validation string
   SWITCH
      CASE d2 = false     :          ; [Esc] was entered
      CASE d2 = 7/21/69   :
         PopBox.u(18,"Too lazy to Enter another Date?!  " + StrVal(d2),1,78,3)
      OTHERWISE           :
         PopBox.u(18,"You Entered the Date: " + StrVal(d2),1,31,3)
   ENDSWITCH
   Message.u("M",0,0)
   Clear Return
ENDPROC
WriteLib libname.a Get_InputValidate.u
Release PROCS      Get_InputValidate.u
?? ""
; ===========================================================================
;       TITLE: Get_InputQBForm.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:43:00am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC Get_InputQBForm.u()
Private  proc.a                         ; Name of current procedure
   proc.a = "Get_InputQBForm.u"
   SetSwap swap.n
   ClearAll
   Message.u("This routine demonstrates Query By Form procedure",0,3)
   QueryByForm.l("l\\DanDemoQ",        ; Table with QBF form
                 (1+form.n),           ; Form to use
                 "d\\DanDemo")         ; Table to be queried

   IF NOT retval THEN
      Message.u("Query By Form Demonstration Canceled - Returning",0,0)
      Return
   ENDIF

   View "Answer"                       ;   display results of query
   WAIT Table Prompt
" You didn't think I would go to the trouble of a Custom Report, Did you?",
" Hit [F2] or [Esc] when Finished Viewing this Answer Table... "
   Until "Dos", "DosBig", "Rotate", "FieldView", "F35", "Zoom", "F2", "Esc",
         "F1", -35
   Message.u("M",0,0)
   Return                              ; Any of the keylist ends demo
ENDPROC
WriteLib libname.a Get_InputQBForm.u
Release PROCS      Get_InputQBForm.u
?? ""
; ===========================================================================
;       TITLE: PrintingFile.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:43:26am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC PrintingFile.u()
Private  file.a,                          ; Name of report file to create
         proc.a                           ; Name of current procedure
   proc.a = "PrintingFile.u"
   SetSwap swap.n
   ClearAll
   file.a = "Test.sc"                     ; Just to show how to use variable
   PrintFile.u("d\\dandemo","1",pica.a,file.a,true)
   Message.u("We will now take a look at the Report File - Hit [Esc] when Done",2,2)
   Run NOREFRESH "Readme " + file.a
   Message.u("M",0,0)
ENDPROC
WriteLib libname.a PrintingFile.u
Release PROCS      PrintingFile.u
?? ""
; ===========================================================================
;       TITLE: PrintingOutput.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:43:39am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC PrintingOutput.u()
Private  file.a,                          ; Name of Report File to use
         proc.a                           ; Name of current procedure
   proc.a = "PrintingOutput.u"
   SetSwap swap.n
   ClearAll
   file.a = "Test.sc"
   IF NOT IsFile(file.a) THEN
      PrintFile.u("d\\dandemo","1",pica.a,file.a,true)
   ENDIF
   PrintSelect.u(file.a,port.a,false,false,false)
   Message.u("M",0,0)
   Return
ENDPROC
WriteLib libname.a PrintingOutput.u
Release PROCS      PrintingOutput.u
?? ""
; ===========================================================================
;       TITLE: PrintingCheckPrn.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:44:03am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC PrintingCheckPrn.u()
Private  netport.a,                       ; Alternate Printer Port selection
         proc.a                           ; Name of current procedure
   proc.a = "PrintingCheckPrn.u"
   SetSwap swap.n
   ClearAll
   Message.u("Make Sure Your Printer is Turned Off",-1,0)
   Array popitems.r[6]
      popitems.r[1] = "LPT1 - Parallel Port 1"
      popitems.r[2] = "LPT2 - Parallel Port 2"
      popitems.r[3] = "LPT3 - Parallel Port 3"
      popitems.r[4] = "COM1 - Serial Port 1"
      popitems.r[5] = "COM2 - Serial Port 2"
      popitems.r[6] = "RETURN to Menu"
   WHILE true
      MenuPop.n(5, 22, "Select Printer Port", 96, 111, 31)
      SWITCH
         CASE retval = 99  : HelpMenu.u("PRINTING") LOOP
         CASE retval = 6
            OR retval = 0   : netport.a = "RETURN"
         OTHERWISE         : netport.a = SubStr(popitems.r[retval],1,4)
      ENDSWITCH
      QUITLOOP
   ENDWHILE
   IF netport.a <> "RETURN" THEN        ; no network printer port
      SetPrinter netport.a       ; Set override printer port
      PrintCheck.l()             ; Check printer status
      IF NOT retval THEN
         Sleep 2000
         Message.u("Remember to Turn Your Printer Back On!",3,3)
      ENDIF
   ENDIF
   Message.u("M",0,0)
   Return
ENDPROC
WriteLib libname.a PrintingCheckPrn.u
Release PROCS      PrintingCheckPrn.u
?? ""
; ===========================================================================
;       TITLE: PrintingRestart.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:44:16am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC PrintingRestart.u()
Private  proc.a                           ; Name of current procedure
proc.a = "PrintingRestart.u"
   SetSwap swap.n
   ClearAll
   Message.u("Sorry, PrintingRestart.l is still in Beta Testing and is unavailable",3,3)
   Return
ENDPROC
WriteLib libname.a PrintingRestart.u
Release PROCS      PrintingRestart.u
?? ""
; ===========================================================================
;       TITLE: VariousListing.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-20-91 08:25:56pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION: Table of Procedures and Parameters, plus example of "Poor Man's
;              Data Entry Tool Kit
; ---------------------------------------------------------------------------
PROC VariousListing.u()
Private  adutility.a,
         aduparams.a,
         col.n,
         proc.a                           ; Name of current procedure
   proc.a = "VariousListing.u"
   SetSwap swap.n
   ClearAll
   View "D\\Utility"
   PickForm (1 + form.n)
   adutility.a = "ABD0"                   ; The Code indicates table has
   aduparams.a = "00BB"                   ;  Arrival/Departure/Both/Neither
   prompt1.a = " Viewing the Procedures Table...    Press [F1]-Help"
   Echo NORMAL Echo OFF
   PopBox.u(10,"This Demonstrates the Poor Man's Data Entry Toolkit, as Well",
            1,79,2)
   ; MF{table}{A/D} represent MoveField {Arrival/Departure} procedures
   ; MF{table}D represents MoveRecord Departure procedures
   WHILE true
      col.n = ColNo() - 1
      IF lower(Table()) = "d\\utility" THEN
         IF SubStr(adutility.a,col.n,1) = "A"
         OR SubStr(adutility.a,col.n,1) = "B" THEN
            ExecProc "MFUtilityA" +StrVal(col.n)+ ".l"
            IF NOT retval THEN
               LOOP
            ENDIF
         ENDIF
      ELSE
         IF SubStr(aduparams.a,col.n,1) = "A"
         OR SubStr(aduparams.a,col.n,1) = "B" THEN
            ExecProc "MFUParamsA" +StrVal(col.n)+ ".l"
            IF NOT retval THEN
               LOOP
            ENDIF
         ENDIF
      ENDIF
      Wait TABLE Prompt prompt1.a,
" [F3] or [F4]-Image     [Ctrl+Z]-Locate     [F2] or [Esc]-Finished"
      Until "Dos", "DosBig", "Rotate", "FieldView", "F35", "Zoom", "ZoomNext",
            "Tab", "ReverseTab", "CtrlPgUp", "CtrlPgDn", "Home", "End",
            "PgUp", "PgDn", "Up", "Down", "Left", "Right", "F3", "F4",
            "F2", "F1", "Esc", -35
      key.v = retval
      MoveField.l()
      SWITCH
         CASE retval AND Lower(Table()) = "d\\utility" :
            IF SubStr(adutility.a,col.n,1) = "D"
            OR SubStr(adutility.a,col.n,1) = "B" THEN
               ExecProc "MFUtilityD" +StrVal(col.n)+ ".l"
               IF NOT retval THEN
                  LOOP
               ENDIF
            ENDIF
         CASE retval AND Lower(Table()) = "d\\uparams" :
            IF SubStr(aduparams.a,col.n,1) = "A"
            OR SubStr(aduparams.a,col.n,1) = "B" THEN
               ExecProc "MFUParamsD" +StrVal(col.n)+ ".l"
               IF NOT retval THEN
                  LOOP
               ENDIF
            ENDIF
      ENDSWITCH
      SWITCH
         CASE retval = -35    :         ; Alt+H
            HelpMenu.u("Various")
            LOOP
         CASE retval = "F1"   :
            LookupHelpKey.u("Various")
            LOOP
         CASE key.v = "F2" OR key.v = "Esc"  :
            PopBox.u(10,"Returning to MAIN MENU...",2,79,1)
            Return
         CASE key.v = "F3" OR key.v = "F4"   :
            IF Lower(Table()) = "d\\utility" THEN
               DownImage
               prompt1.a = " Viewing Parameters for Procedure " +
                            [d\Utility->Procedure] +
                           "...    Press [F1]-Help"
            ELSE
               UpImage
               prompt1.a = " Viewing the Procedures Table...    Press [F1]-Help"
            ENDIF
            LOOP
         CASE key.v = "Zoom" OR key.v = "ZoomNext" :
            LocateMenu.l()
            IF retval THEN
               MoveRecord.l()
               SWITCH
                  CASE retval AND Lower(Table()) = "d\\utility" :
                     MRUtility.l()
                  CASE retval AND Lower(Table()) = "d\\uparams" :
                     MRUParams.l()
               ENDSWITCH
            ENDIF
            LOOP
         CASE key.v = "Dos" OR key.v = "DosBig" OR key.v = "Rotate"
           OR key.v = "FieldView" OR key.v = "F35" :
            Beep LOOP
      ENDSWITCH
      MoveRecord.l()
      SWITCH
         CASE retval AND Lower(Table()) = "d\\utility" :
            MRUtility.l()
            IF NOT retval THEN
               LOOP
            ENDIF
         CASE retval AND Lower(Table()) = "d\\uparams" :
            MRUParams.l()
            IF NOT retval THEN
               LOOP
            ENDIF
      ENDSWITCH
      KeyPress key.v
   ENDWHILE
ENDPROC
WriteLib libname.a VariousListing.u
Release PROCS      VariousListing.u
?? ""
; ===========================================================================
;       TITLE: MFUtilityA1.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-21-91 07:28:07am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MFUtilityA1.l()
Private  proc.a                           ; Name of current procedure
   proc.a = "MFUtilityA1.l"
   Message.u("Moved into the " +Field()+ " Field",1,1)
   Return true
ENDPROC
WriteLib libname.a MFUtilityA1.l
Release PROCS      MFUtilityA1.l
?? ""
; ===========================================================================
;       TITLE: MFUtilityA2.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-21-91 07:28:07am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MFUtilityA2.l()
Private  proc.a                           ; Name of current procedure
   proc.a = "MFUtilityA2.l"
   Message.u("Moved into the " +Field()+ " Field",1,1)
   Return true
ENDPROC
WriteLib libname.a MFUtilityA2.l
Release PROCS      MFUtilityA2.l
?? ""
; ===========================================================================
;       TITLE: MFUtilityD2.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-21-91 07:28:07am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MFUtilityD2.l()
Private  proc.a                           ; Name of current procedure
   proc.a = "MFUtilityD2.l"
   Message.u("Moving out of the " +Field()+ " Field",1,1)
   Return true
ENDPROC
WriteLib libname.a MFUtilityD2.l
Release PROCS      MFUtilityD2.l
?? ""
; ===========================================================================
;       TITLE: MFUtilityD3.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-21-91 07:28:07am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MFUtilityD3.l()
Private  proc.a                           ; Name of current procedure
   proc.a = "MFUtilityD3.l"
   Message.u("Moving out of the " +Field()+ " Field",1,1)
   Return true
ENDPROC
WriteLib libname.a MFUtilityD3.l
Release PROCS      MFUtilityD3.l
?? ""
; ===========================================================================
;       TITLE: MFUParamsA3.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-21-91 07:28:07am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MFUParamsA3.l()
Private  proc.a                           ; Name of current procedure
   proc.a = "MFUParamsA3.l"
   Message.u("Moved into the " +Field()+ " Field",1,1)
   Return true
ENDPROC
WriteLib libname.a MFUParamsA3.l
Release PROCS      MFUParamsA3.l
?? ""
; ===========================================================================
;       TITLE: MFUParamsA4.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-21-91 07:28:07am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MFUParamsA4.l()
Private  proc.a                           ; Name of current procedure
   proc.a = "MFUParamsA4.l"
   Message.u("Moved into the " +Field()+ " Field",1,1)
   Return true
ENDPROC
WriteLib libname.a MFUParamsA4.l
Release PROCS      MFUParamsA4.l
?? ""
; ===========================================================================
;       TITLE: MFUParamsD3.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-21-91 07:28:07am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MFUParamsD3.l()
Private  proc.a                           ; Name of current procedure
   proc.a = "MFUParamsD3.l"
   Message.u("Moving out of the " +Field()+ " Field",1,1)
   Return true
ENDPROC
WriteLib libname.a MFUParamsD3.l
Release PROCS      MFUParamsD3.l
?? ""
; ===========================================================================
;       TITLE: MFUParamsD4.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-21-91 07:28:07am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MFUParamsD4.l()
Private  proc.a                           ; Name of current procedure
   proc.a = "MFUParamsD4.l"
   Message.u("Moving out of the " +Field()+ " Field",1,1)
   Return true
ENDPROC
WriteLib libname.a MFUParamsD4.l
Release PROCS      MFUParamsD4.l
?? ""
; ===========================================================================
;       TITLE: MRUtility.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-21-91 07:31:30am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MRUtility.l()
Private  l,                               ; Logical true/false moving off
         proc.a                           ; Name of current procedure
   proc.a = "MRUtility.l"
   SWITCH
      CASE AtFirst() :
         SWITCH
            CASE  Field() = "Description"
             AND (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "Right" OR key.v = "Tab" OR
                  key.v = "End" OR key.v = "Down" OR
                  key.v = "PgDn" OR key.v = "CtrlPgDn" OR
                  key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            CASE Field() = "Description" :
               l = false
            CASE (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "End" OR key.v = "PgDn" OR key.v = "CtrlPgDn" OR
                  key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            OTHERWISE   :
               l = false
         ENDSWITCH
      CASE AtLast()  :
         SWITCH
            CASE  Field() = "Script"
             AND (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "Left" OR key.v = "ReverseTab" OR
                  key.v = "Home" OR key.v = "Up" OR
                  key.v = "PgUp" OR key.v = "CtrlPgUp" OR
                  key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            CASE Field() = "Script" :
               l = false
            CASE  Field() = "Description"
             AND (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "Home" OR key.v = "PgUp" OR key.v = "CtrlPgUp" OR
                  key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            CASE Field() = "Description" :
               l = false
            CASE (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "Home" OR key.v = "Up" OR
                  key.v = "PgUp" OR key.v = "CtrlPgUp" OR
                  key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            OTHERWISE   :
               l = false
         ENDSWITCH
      OTHERWISE      :
         SWITCH
            CASE Field() = "Script"
             AND (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "Left" OR key.v = "ReverseTab" OR
                  key.v = "Home" OR key.v = "End" OR key.v = "Up" OR
                  key.v = "PgUp" OR key.v = "CtrlPgUp" OR key.v = "PgDn" OR
                  key.v = "CtrlPgDn" OR key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            CASE Field() = "Script" :
               l = false
            CASE Field() = "Description"
             AND (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "Right" OR key.v = "Tab" OR
                  key.v = "Home" OR key.v = "End" OR key.v = "Down" OR
                  key.v = "PgUp" OR key.v = "CtrlPgUp" OR key.v = "PgDn" OR
                  key.v = "CtrlPgDn" OR key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            CASE Field() = "Description" :
               l = false
            CASE (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "Home" OR key.v = "End" OR key.v = "Up" OR
                  key.v = "PgUp" OR key.v = "CtrlPgUp" OR key.v = "PgDn" OR
                  key.v = "CtrlPgDn" OR key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            OTHERWISE   :
               l = false
         ENDSWITCH
   ENDSWITCH
   IF l THEN
      Message.u("Moving from Record #" +StrVal(RecNo())+ " in " + Table(),1,1)
   ENDIF
   Return true
ENDPROC
WriteLib libname.a MRUtility.l
Release PROCS      MRUtility.l
?? ""
; ===========================================================================
;       TITLE: MRUParams.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-21-91 07:31:49am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MRUParams.l()
Private  l,                               ; Logical true/false moving off
         proc.a                           ; Name of current procedure
   proc.a = "MRUParams.l"
   SWITCH
      CASE AtFirst() :
         SWITCH
            CASE  Field() = "Parameter"
             AND (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "End" OR key.v = "Down" OR
                  key.v = "PgDn" OR key.v = "CtrlPgDn" OR
                  key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            CASE Field() = "Parameter" :
               l = false
            CASE  Field() = "Description"
             AND (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "Right" OR key.v = "Tab" OR
                  key.v = "End" OR key.v = "Down" OR
                  key.v = "PgDn" OR key.v = "CtrlPgDn" OR
                  key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            CASE Field() = "Description" :
               l = false
            OTHERWISE   :
               l = false
         ENDSWITCH
      CASE AtLast()  :
         SWITCH
            CASE  Field() = "Parameter"
             AND (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "Left" OR key.v = "ReverseTab" OR
                  key.v = "Home" OR key.v = "Up" OR
                  key.v = "PgUp" OR key.v = "CtrlPgUp" OR
                  key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            CASE Field() = "Parameter" :
               l = false
            CASE  Field() = "Description"
             AND (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "Home"  OR key.v = "Up" OR
                  key.v = "PgUp" OR key.v = "CtrlPgUp" OR
                  key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            CASE Field() = "Description" :
               l = false
            OTHERWISE   :
               l = false
         ENDSWITCH
      OTHERWISE      :
         SWITCH
            CASE  Field() = "Parameter"
             AND (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "Left" OR key.v = "ReverseTab" OR
                  key.v = "Home" OR key.v = "End" OR key.v = "Down" OR key.v = "Up" OR
                  key.v = "PgUp" OR key.v = "CtrlPgUp" OR key.v = "PgDn" OR
                  key.v = "CtrlPgDn" OR key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            CASE Field() = "Parameter" :
               l = false
            CASE  Field() = "Description"
             AND (key.v = "F3" OR key.v = "F4" OR key.v = "F2" OR key.v = "Esc" OR
                  key.v = "Right" OR key.v = "Tab" OR
                  key.v = "Home" OR key.v = "End" OR key.v = "Down" OR key.v = "Up" OR
                  key.v = "PgUp" OR key.v = "CtrlPgUp" OR key.v = "PgDn" OR
                  key.v = "CtrlPgDn" OR key.v = "Zoom" OR key.v = "ZoomNext") :
               l = true
            CASE Field() = "Description" :
               l = false
            OTHERWISE   :
               l = false
         ENDSWITCH
   ENDSWITCH
   IF l THEN
      Message.u("Moving from Record #" +StrVal(RecNo())+ " in " + Table(),1,1)
   ENDIF
   Return true
ENDPROC
WriteLib libname.a MRUParams.l
Release PROCS      MRUParams.l
?? ""
; ===========================================================================
;       TITLE: VariousError.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:44:39am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC VariousError.u()
Private  proc.a                           ; Name of current procedure
   proc.a = "VariousError.u"
      SetSwap swap.n
      ClearAll
   Message.u("This demonstrates the Error procedures but then continues the Demo",0,3)
   Message.u("The program will now attempt to View table \"IZNTHERE\"",-1,0)
   View "IZNTHERE"                         ; Table does not exist (I Hope!)
   Clear ClearAll
   Message.u("Viewing ErrorLog via Readme.com - Hit [Esc] when finished",0,3)
   Run NOREFRESH "Readme Err\\Errorlog.sc"      ; Display created errorlog
   Message.u("M",0,0)
   Return
ENDPROC
WriteLib libname.a VariousError.u
Release PROCS      VariousError.u
?? ""
; ===========================================================================
;       TITLE: VariousPack.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:44:55am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC VariousPack.u()
Private  proc.a                           ; Name of current procedure
proc.a = "VariousPack.u"
   SetSwap swap.n
   Clear ClearAll                         ; Normally, we would Pack All Tables
   Message.u("This will Pack and Rebuild two Tables as a demo",-1,0)
   Packer.u()                             ; Controlled by BAK\\TabList Table
   Message.u("M",0,0)
   Return
ENDPROC
WriteLib libname.a VariousPack.u
Release PROCS      VariousPack.u
?? ""
; ===========================================================================
;       TITLE: VariousRecover.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:45:27am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC VariousRecover.u()
Private  proc.a                           ; Name of current procedure
proc.a = "VariousRecover.u"
   SetSwap swap.n
   Clear ClearAll                         ; Normally, we would recover All
   Message.u("This will Recover Family Objects for two Tables as a demo",-1,0)
   Family.u()                             ; Controlled by BAK\\TabList Table
   Message.u("M",0,0)
   Return
ENDPROC
WriteLib libname.a VariousRecover.u
Release PROCS      VariousRecover.u
?? ""
; ===========================================================================
;       TITLE: VariousOthers.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:45:41am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC VariousOthers.u()
Private  echo.a,                       ; Speed for demo
         proc.a                        ; Name of current procedure
   proc.a = "VariousOthers.u"
   SetSwap swap.n
   ClearAll
   PaintCanvas FILL "" 0,0,24,79
   echo.a = VariousSpeed.a()
   Message.u("This creates Temporary table like Permanent table, with family",0,3)
   CreateTable.l("d\\dandemo","Answer"); for demo purposes
   IF NOT retval THEN                  ; Table was locked
      Message.u("I wonder who locked the DANDEMO table? - Try again later.",1,3)
      Return
   ENDIF
   ClearAll

   Message.u("This Presents CancelEdit Menu, using the Menu Prompt on line 2",0,3)
      Edit "Answer"
      Echo OFF                            ; Synchronize workspace and canvas
      Execute "Echo " +echo.a             ; Re-establish Slowdown
      CancelSession.l("Cancel this Editing Session?")   ; Cancel-edit routine
      IF NOT retval THEN
         Message.u("You Pressed [NO], but we have to Move on - Edit Canceled",1,3)
         CancelEdit
      ENDIF
      Clear ClearAll

   Message.u("This deletes a table if it exists <demo uses Answer table>",0,3)
      DeleteTable.u("Answer")

   Message.u("This checks for Answer Table - Without Hit Any Key routine",0,3)
      NoAnswer.l("No ANSWER table was located - continuing with the Demo",false)

   Message.u("This checks for Answer Table - With Hit Any Key routine",0,3)
      NoAnswer.l("Wakeup!!!  I told you there was no Answer Table!",true)

   Message.u("This is what the User sees when the application isn't finished",0,3)
      NotDone.u()

   Execute "Echo " +echo.a                ; Re-establish Slowdown
   PopBox.u(10,"Well, as I said, they are not very impressive!",2,33,2)
   Message.u("M",0,0)
   Return
ENDPROC
WriteLib libname.a VariousOthers.u
Release PROCS      VariousOthers.u
?? ""
; ===========================================================================
;       TITLE: VariousSpeed.a
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-30-91 03:44:39am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC VariousSpeed.a()
Private proc.a, popitems.r
   proc.a = "VariousSpeed.a"
   Array popitems.r[5]
      popitems.r[1] = "NO_DELAY - (Echo OFF)"
      popitems.r[2] = "FAST     - (Echo NORMAL)"
      popitems.r[3] = "MEDIUM   - (Echo FAST)"
      popitems.r[4] = "SLOW     - (Echo SLOW)"
      popitems.r[5] = "CANCEL   - (No Change)"
   MenuPop.n(3,0,"Select Speed of Demo",111,110,30)
   Clear
   SWITCH
      CASE retval = 1   : Echo OFF Return "OFF"
      CASE retval = 2   : Echo NORMAL Return "NORMAL"
      CASE retval = 3   : Echo FAST Return "FAST"
      CASE retval = 4   : Echo SLOW Return "SLOW"
   ENDSWITCH
ENDPROC
WriteLib libname.a   VariousSpeed.a
Release PROCS        VariousSpeed.a
?? ""