? " Utility3.sc"
@ Row(),13 ?? Fill("",21)
@ Row(),13
libname.a = "Utility"
IF NOT IsFile(libname.a + ".LIB") THEN
   CreateLib libname.a SIZE 100
ENDIF
; ===========================================================================
;       TITLE: Message.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;              Based upon an idea by Alan Zenreich
;     CREATED: June, 1987           LAST REVISED: 01-11-91 09:51pm
;     RETURNS: no value
; DESCRIPTION: Generic Information message
; ---------------------------------------------------------------------------
PROC Message.u(msg.a,                  ; Message to display (1 line, <75 chars)
               beep.n,                 ; Number of beeps (<0 = Hit Any Key)
               sleep.n)                ; Time to pause (0 to 5 seconds)
Private  uproc.a,                      ; Name of this proc
         n,                            ; Loop incrementer
         attrib.n                      ; Display attribute
   uproc.a = "Message.u"
   SWITCH
      CASE beep.n < 0
        OR beep.n > 2   : attrib.n = SysColor(3)
      CASE NOT color.l  : attrib.n = SysColor(16)
      CASE beep.n = 0   : attrib.n = 49
      OTHERWISE         : attrib.n = 31
   ENDSWITCH

   SWITCH                                  ; shortcuts
      CASE msg.a = "C": msg.a = "Operation Canceled - Returning"
      CASE msg.a = "M": msg.a = "One Moment - Returning to MENU"
      CASE msg.a = "Q": msg.a = "Q U E R Y I N G  -  This will take a few moments"
      CASE msg.a = "R": msg.a = "Report NOT Printed - Returning"
      CASE msg.a = "W": msg.a = "W O R K I N G  -  One Moment"
   ENDSWITCH

   Style ATTRIBUTE attrib.n

   @ 0,0 ?? Fill(" ",240)              ; clear and color top three lines
   @ 0,0                               ; make a BIG box (indent 1 space)
   TEXT
 ͻ
                                                                             
 ͼ
   ENDTEXT

   @ 1,Int((80 - Len(msg.a)) / 2)   ; center message
   ?? msg.a
   Style ATTRIBUTE attrib.n + 128
      ?? "..."
   Style

   IF beep.n < 0 THEN                  ; Pause, keep Beeping, and wait for
      Beeper.u()                       ;   a key press
      Return
   ELSE
      FOR n from 1 to Min(5,beep.n)
         Beep Sleep 100
      ENDFOR
   ENDIF

   IF sleep.n > 0 THEN                 ; Sleep range from 0 to 5 seconds
      Sleep (Min(5,sleep.n) * 1000)    ; Wait appropriate number of seconds
   ENDIF
   Return
ENDPROC
WriteLib libname.a   Message.u
Release PROCS        Message.u
?? ""
; ===========================================================================
;       TITLE: MoveField.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-21-91 06:23:23am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MoveField.l()
Private  uproc.a                          ; Name of current procedure
;Global  key.v
   uproc.a = "MoveField.l"
   IF key.v = "Ins"     OR key.v = "F2"         OR key.v = "Esc"
   OR key.v = "Up"      OR key.v = "Down"       OR key.v = "Left"
   OR key.v = "Right"   OR key.v = "PgUp"       OR key.v = "PgDn"
   OR key.v = "Home"    OR key.v = "End"        OR key.v = "F3"
   OR key.v = "F4"      OR key.v = "CtrlPgUp"   OR key.v = "CtrlPgDn"
   OR key.v = "Tab"     OR key.v = "ReverseTab" OR key.v = "CtrlHome"
   OR key.v = "CtrlEnd" OR key.v = "ZoomNext"   OR key.v = "Zoom" THEN
      Return true
   ELSE
      Return false
   ENDIF
ENDPROC
WriteLib libname.a MoveField.l
Release PROCS      MoveField.l
?? ""
; ===========================================================================
;       TITLE: MoveRecord.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-21-91 06:23:23am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION:
; ---------------------------------------------------------------------------
PROC MoveRecord.l()
Private  uproc.a                          ; Name of current procedure
;Global  key.v
   uproc.a = "MoveRecord.l"
   IF key.v = "Ins"     OR key.v = "F2"         OR key.v = "Esc"
   OR key.v = "Up"      OR key.v = "Down"       OR key.v = "Left"
   OR key.v = "Right"   OR key.v = "PgUp"       OR key.v = "PgDn"
   OR key.v = "Home"    OR key.v = "End"        OR key.v = "F3"
   OR key.v = "F4"      OR key.v = "CtrlPgUp"   OR key.v = "CtrlPgDn"
   OR key.v = "Tab"     OR key.v = "ReverseTab" OR key.v = "ZoomNext"
   OR key.v = "Zoom"    THEN
      Return true
   ELSE
      Return false
   ENDIF
ENDPROC
WriteLib libname.a MoveRecord.l
Release PROCS      MoveRecord.l
?? ""
; ===========================================================================
;       Title - NoAnswer.l
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - logical true/false if No Answer table located or IsEmpty
;  Chronology - Created: October, 1987     Last revised: 03/02/90 09:22am
; Description - Generic Check for No Answer Table
; ---------------------------------------------------------------------------
PROC NoAnswer.l(msg.a,              ; message to display if no answer
                beeper.l)           ; whether to call Beeper.u()
Private uproc.a
    uproc.a = "NoAnswer.l"
    IF not IsTable("Answer") or IsEmpty("Answer") THEN
        IF beeper.l THEN
            Message.u(msg.a,-1,0)       ; annoying beeper gets attention
        ELSE
            Message.u(msg.a,3,2)        ; not so annoying
        ENDIF

        Return true
    ELSE

        Return false
    ENDIF
ENDPROC
WriteLib libname.a NoAnswer.l
Release PROCS NoAnswer.l
?? ""
; ===========================================================================
;       Title - NotDone.u
;      AUTHOR - (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - no value
;  Chronology - Created: August, 1989    Revised: 11/25/90 09:42pm
; Description - Generic Not Done
;--------------------------------------------------------------
PROC NotDone.u()
   Message.u("This feature is undergoing testing - It is not yet available.",-1,0)
   Return
ENDPROC
WriteLib libname.a NotDone.u
Release PROCS NotDone.u
?? ""
; ===========================================================================
;       Title - OkKey3.l
;      Author - (c) 1991 - Zenreich/Kocis
;     Returns - Logical true/false if key already exists
;  Revised By - Daniel J. Paolini II, CMA    Last Revised: 01-11-91 09:50pm
; Description - Checks for key violation in CoEdit mode.
; ---------------------------------------------------------------------------
PROC OKKey3.l(requiredcheck.l)          ; ReInstate Required Fields?
Private uproc.a,
        field.a,         ; Current field name.
        r,               ; Temporary array.
        a,               ; Window() message.
        ok.l,            ; Is record okay (no key conflict)?
        error.n,         ; Errorcode for keyviolation or write lock.
        n
   uproc.a = "OkKey3.l"
   IF NKeyFields(Table()) = 0 THEN
      ok.l = true      ; No key fields, cannot possibly be a key conflict.
   ELSE               ; There must be key fields.
      RequiredCheck OFF     ; Helps deal with required valcheck and empty fields.
      CopyToArray r         ; For safekeeping.
      ImageRights           ; Make sure that we have rights to do this.
      Del                   ; Attempt to remove the current record.
      SWITCH
         CASE Search("Can't delete master", WINDOW()) = 1 : ; Must be a master table.
            field.a = Field()   ; in case RESYNCKEY jumps to another MTF page
            ReSyncKey           ; Shows a key conflict without unlocking
            error.n = ErrorCode()
            ok.l = (error.n <> 53       ; Error.n 53 is set if key exists;
                     and error.n <> 3)   ; error.n 3 if a Write Lock is on table.
            MoveTo FIELD field.a ; Paradox3 sometimes jumps to another field or page.
         OTHERWISE:             ; Detail record, or not a master with details.
            Ins                  ; Insert a blank, unposted record.
            CopyFromArray3.u("r", requiredcheck.l)
            KeyLookup            ; Attempt toggle to possible offending key.
            error.n = ErrorCode()
            a = ErrorMessage()
            IF Match(a,"keylookup can not..") THEN  ; 3.01 doesn't allow KEYLOOKUP
                                                      ; in master.
               ReSyncKey
               error.n = ErrorCode()
               ok.l = (error.n <> 53 and error.n <> 3)
                                          ; Error.n 53 is set if key exists;
                                          ; error.n 3 if a Write Lock is on table.
            ELSE
               ok.l = Error.n = 56         ; If can't find lookup, then key is ok.
            ENDIF

            IF ok.l THEN         ; Lookupkey not found.
               LockRecord         ; Record posts, and cursor remains with it.
            ELSE
               KeyLookup          ; Return to record values as operator entered.
            ENDIF
      ENDSWITCH
   ENDIF

   IF NOT ok.l THEN
      SWITCH
         CASE error.n = 3 :     ; Possible Write Lock.
            Message.u("Table locked by: "+ERRORUSER()+ ". Cannot verify key.",-1,0)
            PopBox.u(10,"Record Canceled!",SysColor(3),0,2)
            Del
            ok.l = true
         OTHERWISE:
            WHILE true
               Style ATTRIBUTE SysColor(3)
               @ 0,0 ?? Format("W80"," A Record with the same Key Value already Exists")
               @ 1,0 ?? Format("w80"," Please Resolve the Conflict between the Records")
               @ 2,0 ?? Fill("",80)
               Style
               Array popitems.r[4]
                  popitems.r[1] = "TOGGLE Duplicate"
                  popitems.r[2] = "REPLACE Original"
                  popitems.r[3] = "CANCEL New Record"
                  popitems.r[4] = "EDIT New Record"
               n = MenuPop.n(0,56,"Resolve Conflict",64,79,31)
               SWITCH
                  CASE n = 0 : Beep
                  CASE n = 1 :
                     KeyLookup
                     Echo NORMAL Echo OFF
                  CASE n = 2 :
                     LockRecord
                     QUITLOOP
                  CASE n = 3 :
                     Del Ins
                     QUITLOOP
                  CASE n = 4 :
                     Del Ins
                     CopyFromArray3.u("r", requiredcheck.l)
                     QUITLOOP
                  CASE n = 99: HelpMenu.u("CONFLICT")
               ENDSWITCH
            ENDWHILE
            ok.l = (n = 2)
      ENDSWITCH
   ENDIF

   IF RequiredCheck.l <> false THEN
      RequiredCheck ON
   ENDIF
   Return ok.l
ENDPROC
WriteLib libname.a OkKey3.l
Release PROCS OkKey3.l
?? ""
; ===========================================================================
;       TITLE: Packer.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 01-06-91 09:14:53pm     Last Revised:
;     RETURNS: No Value
; DESCRIPTION: Packs tables in "BAK\\Tablist" to remove empty space.
; ---------------------------------------------------------------------------
PROC Packer.u()
Private  uproc.a,                          ; Name of current procedure
         rec.n,
         n,
         tables.r,
         path.r
   uproc.a = "Packer.u"
   IF NOT DirExists("Bak") = 1 OR NOT IsTable("Bak\\tablist") THEN
      Message.u("The TABLIST Table is missing from the BAK Directory",-1,0)
      Return
   ENDIF
   View "Bak\\tablist"
   MoveTo [Name]
   rec.n = NImageRecords()
   Array tables.r[rec.n]
   Array path.r[rec.n]
   SCAN
      tables.r[RecNo()] = []
      path.r[RecNo()] = [Path]
   ENDSCAN
   ClearAll
   For n From 1 To rec.n
      Message.u("Packing Table #" +StrVal(n)+ " of " +StrVal(rec.n)+ " Tables",1,0)
      Copy "BAK\\" + tables.r[n] "Backup"
      {Ask} Select path.r[n] + tables.r[n]
      CheckPlus
      Do_It!
      Add "Answer" "Backup"                     ; Use a permanent table name, just in
      Rename "Backup" path.r[n] + tables.r[n]   ;  case of an ABEND, we can recover data
      ClearAll
   ENDFOR
   SetDir Directory()                  ; Flushes Buffers
   Message.u("Packing is finished",3,1)
ENDPROC
WriteLib libname.a Packer.u
Release PROCS      Packer.u
?? ""
; ===========================================================================
;       Title - PaintMenu.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No value
;  Chronology - Created: 01/27/90 11:50am
; Description - Generic Screen Painter for Menus.  Does not use uproc.a
; ---------------------------------------------------------------------------
PROC PaintMenu.u()
    IF color.l THEN         ;Set Canvas Display Colors on blue except where noted
        PaintCanvas ATTRIBUTE 31 0,0,24,79      ; default screen        white
        PaintCanvas ATTRIBUTE 79 2,0,2,79       ; cursor prompt         white on red
        PaintCanvas ATTRIBUTE 16 3,0,3,79       ; prompt shadow         black
        PaintCanvas ATTRIBUTE 23 19,0,24,79     ; general help section  grey
        PaintCanvas ATTRIBUTE 16 4,16,5,65      ; title border          black
        PaintCanvas ATTRIBUTE 49 4,15,4,64      ; menu title            blue on cyan
        PaintCanvas ATTRIBUTE 30 6,1,23,10      ; menu keywords         yellow
        PaintCanvas ATTRIBUTE 31 19,1,19,10     ; key help title        white
        PaintCanvas ATTRIBUTE 19 6,12,23,12     ; menu bullets        cyan
    ELSE
        PaintCanvas ATTRIBUTE SysColor(8)  0,0,24,79      ; default screen
        PaintCanvas REVERSE      2,0,2,79       ; cursor prompt
        PaintCanvas REVERSE      4,15,4,64      ; menu title
    ENDIF
ENDPROC
WriteLib libname.a PaintMenu.u
Release PROCS PaintMenu.u
?? ""
; ===========================================================================
;       TITLE: PopBox.u                                Ŀ  ͻ
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA   0    1    2 
;                             dp Solutions, Inc.         ͼ
;     CREATED: November, 1989     Last Revised: 03-09-91 03:17pm
;     RETURNS: No Value
; DESCRIPTION: Generic Message Box - Popup using IBM graphics for block,
;              single and double-line boxes.  No error checking.
; ---------------------------------------------------------------------------
PROC PopBox.u(msgrow.n,         ; row to center message
              msg.a,            ; message, not longer than 75
              type.n,           ; 0=Block, 1=Single, 2=Double
              attrib.n,         ; color for box, mod(attrib.n,17) <> 0
              sleep.n)          ; sleep seconds, <0=Beeper.u() and GetChar()
Private uproc.a,
        blc.a,                  ; bottom left corner character
        bot.a,                  ; bottom character
        bottom.n,               ; coordinates (row)
        brc.a,                  ; bottom rright corner character
        left.n,                 ; coordinates (col)
        length.n,               ; message length
        right.n,                ; coordinates (col)
        side.a,                 ; side character
        tlc.a,                  ; top left corner character
        top.a,                  ; top character
        top.n,                  ; coordinates (row)
        trc.a                   ; top right corner character
   uproc.a = "PopBox.u"
   length.n = Len(msg.a)                   ; how long is msg
   top.n    = msgrow.n - 1                 ; top
   left.n   = Int((76 - length.n) / 2)     ; left
   bottom.n = msgrow.n + 1                 ; bottom
   right.n  = left.n + length.n + 3        ; right
   tlc.a   = SubStr("",type.n+1,1)  ; top left corner
   top.a   = SubStr("",type.n+1,1)  ; top line
   trc.a   = SubStr("ۿ",type.n+1,1)  ; top right corner
   side.a  = SubStr("۳",type.n+1,1)  ; sides
   brc.a   = SubStr("ټ",type.n+1,1)  ; bottom right corner
   bot.a   = SubStr("",type.n+1,1)  ; bottom line
   blc.a   = SubStr("",type.n+1,1)  ; bottom left corner

   Cursor OFF                          ; Note interesting use of FILL modifier,
                                       ;  as FILL string scrolls top to bottom,
                                       ;  left to right, throughout the border.
   PaintCanvas BORDER FILL tlc.a + Fill(top.a,length.n+2) + trc.a +
                           side.a + side.a +
                           blc.a + Fill(bot.a,length.n+2) + brc.a
                           top.n, left.n, top.n+2, right.n

   @ msgrow.n,left.n+1 ?? Spaces(right.n-left.n-1)
   @ msgrow.n,left.n+2 ?? msg.a
   IF color.l THEN                     ; color screen
      PaintCanvas ATTRIBUTE attrib.n  top.n, left.n, top.n+2, right.n
   ELSE
      PaintCanvas INTENSE  top.n, left.n, top.n+2, right.n
   ENDIF

   IF color.l THEN                               ; shadow dark grey on black
      PaintCanvas ATTRIBUTE 8  msgrow.n+2, left.n+2,  msgrow.n+2, right.n+2
      PaintCanvas ATTRIBUTE 8  msgrow.n,   right.n+1, msgrow.n+1, right.n+2
   ENDIF

   IF sleep.n < 0 THEN                 ; beep and/or sleep
      Beeper.u()
   ELSE
      Beep Sleep (sleep.n * 1000)
   ENDIF
   Style
   Return
ENDPROC
WriteLib libname.a PopBox.u
Release PROCS PopBox.u
?? ""
; ===========================================================================
;       TITLE: PrintCheck.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: July, 1987           LAST REVISED: 01-11-91 04:32am
;     RETURNS: logical true or false if printer available
; DESCRIPTION: Generic printer status, called from ErrorProc
; ---------------------------------------------------------------------------
PROC PrintCheck.l()
Private  uproc.a,                         ; Name of this proc
         l
   uproc.a = "PrintCheck.l"
   Message.u("Checking to see if the printer is ready",0,0)
   WHILE NOT PrinterStatus()
      Message.u("The Printer is Not Responding - Please Check Printer",0,0)
      l = MenuPop2.l(3, 21, "Fix Printer or Select CANCEL", "CANCEL", "DO-IT!",
                    "Printer is NOT Available",
                    "Problem fixed - Try Again",
                     79, 78, 14, false)
      IF NOT l THEN
         Message.u("R",3,0)
         Return false
      ENDIF
   ENDWHILE
   Return true
ENDPROC
WriteLib libname.a PrintCheck.l
Release PROCS PrintCheck.l
?? ""
; ===========================================================================
;       TITLE: PrintFile.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 11/13/90 04:16pm     LAST REVISED: 01-11-91 04:32am
;     RETURNS: No Value
; DESCRIPTION: Prints a Report to a designated File Name
; ---------------------------------------------------------------------------
PROC PrintFile.u(table.a,                 ; Table to Report on
                 report.a,                ; Report to Output
                 setup.a,                 ; Default Setup String
                 file.a,                  ; Name of File to Output to
                 change.l)                ; Allow Change of Default Setup?
Private  uproc.a,                         ; Name of this proc
         l,
         setup.v                          ; Override Setup String
   uproc.a = "PrintFile.u"
   Clear
   IF change.l THEN
      l = MenuPop2.l(3, 21, "Override the Printer Setup String?", "NO", "YES",
                    "Keep Default Setup String",
                    "Select New Setup String",
                     32, 47, 15, false)
      IF l THEN
         setup.v = GetInput.v(3,"Enter Override Printer Setup String","A24","")
   ;                "PICTURE \"*{\\*{?,#}}\"")
         IF NOT setup.v = false THEN
            setup.a = setup.v
         ENDIF
      ENDIF
   ENDIF
   Message.u("W",0,0)                     ; Selects new Setup string
   {Report} {Change} Select table.a Select report.a Enter
   {Setting} {Setup} {Custom} Enter Select setup.a
   {Output} {File} Select file.a       ; Outputs to File
   IF MenuChoice() = "Cancel" THEN
      {Replace}
   ENDIF
   CtrlBreak                              ; Cancels Changes and exits Report
   Return
ENDPROC
WriteLib libname.a PrintFile.u
Release PROCS PrintFile.u
?? ""
; ===========================================================================
;       TITLE: PrintOther.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: 02-12-91 04:53:58am     Last Revised:
;     RETURNS: No Value
; DESCRIPTION: Select Printer Port or call custom Printer Selection routine
; ---------------------------------------------------------------------------
PROC PrintOther.u()
Private  popitems.r,
         uproc.a                          ; Name of current procedure
   uproc.a = "PrintOther.u"
   IF NOT custom.v = false THEN  ; Custom Printer Routine
      ExecProc custom.v          ; Must return Port or "RETURN"
      netport.a = retval
   ELSE
      Array popitems.r[6]
         popitems.r[1] = "LPT1 - Parallel Port 1"
         popitems.r[2] = "LPT2 - Parallel Port 2"
         popitems.r[3] = "LPT3 - Parallel Port 3"
         popitems.r[4] = "COM1 - Serial Port 1"
         popitems.r[5] = "COM2 - Serial Port 2"
         popitems.r[6] = "RETURN to Menu"
      WHILE true
         MenuPop.n(5, 22, "Select Printer Port", 96, 111, 31)
         SWITCH
            CASE retval = 99  : HelpMenu.u("PRINTING") LOOP
            CASE retval = 6
              OR retval = 0   : netport.a = "RETURN"
            OTHERWISE         : netport.a = SubStr(popitems.r[retval],1,4)
         ENDSWITCH
         QUITLOOP
      ENDWHILE
   ENDIF

   IF netport.a <> "RETURN" THEN        ; no network printer port
      IF pause.l THEN
         Message.u("Make sure Printer is Ready with the proper paper",-1,0)
      ENDIF
      SetPrinter netport.a       ; Set override printer port
      PrintCheck.l()             ; Check printer status
      IF retval THEN             ; Send to network port
         Run NOREFRESH "Copy " +report.a+ " " +netport.a+ ":"
         Message.u("Returning",0,0)
      ENDIF
   ENDIF
   Return
ENDPROC
WriteLib libname.a PrintOther.u
Release PROCS      PrintOther.u
?? ""
; ===========================================================================
;       TITLE: PrintSelect.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     RETURNS: No Value
;     CREATED: 09/10/90 01:08pm     LAST REVISED: 01-11-91 04:32am
; DESCRIPTION: Generic Output Loop
; ---------------------------------------------------------------------------
PROC PrintSelect.u(report.a,              ; name of report file
                   default.a,             ; default printer port for Local
                   custom.v,              ; Custom Printer Select or false
                   pause.l,               ; Pause before Printing?
                   save.l)                ; true = save report
Private  uproc.a,
         menu.a,                          ; destination for report
         file.a,                          ; name for saved report file
         l,
         popitems.r,
         netport.a                        ; selected network port
   uproc.a = "PrintSelect.u"
   Array popitems.r[5]
      popitems.r[1] = "DEFAULT Printer"
      popitems.r[2] = "SCREEN Display"
      popitems.r[3] = "OTHER Printer"
      popitems.r[4] = "FILE on Disk"
      popitems.r[5] = "RETURN - Done"
   WHILE true
      Clear
      PaintCanvas FILL "" 0,0,24,79
      MenuPop.n(3, 0, "Select Destination", 32, 47, 31)
      SWITCH
         CASE retval = 99  : HelpMenu.u("PRINTING") LOOP
         CASE retval = 1   :
            IF pause.l THEN
               Message.u("Make sure Printer is Ready with the proper paper",-1,0)
            ENDIF
            PrintCheck.l()                ; Check printer status
            IF retval THEN
               Run NOREFRESH "Copy " +report.a+ " " +port.a
            ENDIF
         CASE retval = 2   :
            Message.u("Report is being sent to the Screen - Hit [Esc] when Finished",1,1)
            Canvas OFF
            Run NOREFRESH "Readme " + report.a
         CASE retval = 3   : PrintOther.u()
         CASE retval = 4   :
            file.a = GetInput.v(6,"Enter Full Path and File Name","A40","")
            IF file.a = false THEN
               LOOP
            ENDIF
            IF IsFile(file.a) THEN        ; Whoops!
               l = MenuPop2.l(3, 21, "That Filename Exists - Overwrite?",
                             "NO", "YES",
                             "Do NOT Overwrite - Try again",
                             "Overwrite the existing File",
                              32, 47, 15, false)
               IF NOT l THEN
                  LOOP
               ENDIF
            ENDIF                         ; Save to specified file name
            Canvas OFF
            RUN NOREFRESH "Copy " +report.a+ " " +file.a
         OTHERWISE         : QUITLOOP
      ENDSWITCH
   ENDWHILE
   IF NOT save.l THEN                     ; Then Delete the original File
      Run NOREFRESH "Del " +report.a+ " > NUL"
      Message.u("Returning",0,0)
   ENDIF
   Canvas ON
   Return
ENDPROC
WriteLib libname.a PrintSelect.u
Release PROCS PrintSelect.u
?? ""
; ===========================================================================
;       TITLE: Prompt.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     CREATED: February, 1988       LAST REVISED: 01-11-91 09:58pm
;     RETURNS: no value
; DESCRIPTION: Generic Super Prompt for one line messages.  Note that it does
;              use the uproc.a convention.  It is considered to be part of
;              whatever procedure called it, as any error would be caused by
;              the calling procedure.
; ---------------------------------------------------------------------------
PROC Prompt.u(msg.a,                      ; Message to Display
              row.n)                      ; Row Number to Display at
   Beep Style ATTRIBUTE SysColor(3)       ; Usually White on Red
   @ row.n,0 ?? Format("w80,ac"," " +msg.a+ " ")
   Style
ENDPROC
WriteLib libname.a Prompt.u
Release PROCS Prompt.u
?? ""
; ===========================================================================
;       Title - QueryByForm.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - Logical true/false if procedure canceled
;  Chronology - Created: 05/16/90 05:04pm    Revised: 07/11/90 01:05pm
; Description - Uses a form from a QBF table to accept search criteria that
;               mimics the table to be queried.  The QBF table has the same
;               field names, but the types are all alphanumeric, so patterns
;               and operators can be used for date and numeric fields.  The
;               procedure does not allow the CHANGETO operator.  This is set
;               up for one table queries, only, at this time.
; ---------------------------------------------------------------------------
PROC QueryByForm.l(qbftable.a,      ; name of table with Query Form
                   qbform.a,        ; number of form to be used for input
                   qbftarget.a)     ; name of table to be queried
Private uproc.a,
        qbf.r,                      ; array of selection criteria
        n,                          ; loop counter
        l,                          ; loop logical
        fields.n                    ; Number of fields in QBFtable

   uproc.a = "QueryByForm.l"
   CreateTable.l(qbftable.a,"Family")
   Message.u("W",0,0)
   Edit "Family"
   RequiredCheck OFF
   PickForm qbform.a
   RequiredCheck ON

   WHILE true
      Wait RECORD Prompt
" Enter the Criteria for this Query and Hit [F2] to Continue, [Esc] to Cancel.",
" You may use Patterns [..] and [@], [Like], and Math Operators [ + - > = < ]."
      Until "Dos", "DosBig", "F35", "FieldView", "Zoom", "Ins", "Rotate",
            "Del", "F2", "Esc", "F1", -35

      SWITCH
         CASE retval = "F1"
           OR retval = -35    : HelpMenu.u("QUERIES")
         CASE retval = "Esc"  :
            CancelSession.l("Cancel this Query?")
            IF retval THEN
               Return false                ; canceled
            ENDIF
         CASE retval = "F2"   :
            FormKey
            CtrlHome
            fields.n = NFields("Family")
            FOR n FROM 1 TO fields.n
               IF Search("CHANGETO",Format("cu",[])) = 1 THEN
                  Message.u("Sorry, You cannot use CHANGETO in this Query",3,2)
                  FormKey
                  l = true
                  QUITLOOP
               ENDIF
               IF n = NFields("Family") THEN
                  l = false
                  QUITLOOP
               ELSE
                  Right
               ENDIF
            ENDFOR
            IF l THEN
               LOOP
            ENDIF
         OTHERWISE   : Beep LOOP
      ENDSWITCH

      CopyToArray qbf.r       ; save criteria to array
      CancelEdit              ; no sense saving this data
      Clear ClearAll
      Message.u("Q",0,0)
      {Ask} Select qbftarget.a                ; manual query of table
      Check
      FOR n FROM 1 TO ArraySize(qbf.r)-1      ; assign array values
         Right
         [] = qbf.r[Field()]
      ENDFOR
      Do_It!
      IF Window() = "" THEN
         NoAnswer.l("Sorry, No Records were Located with that Query",false)
         IF retval THEN
            MenuPop2.l(2,24,"Try Again?","DO-IT!","CANCEL",
                      "Another Query","Return to Menu",78,79,31,true)
            IF NOT retval THEN
               Clear ClearAll
               Return false
            ENDIF
            LOOP
         ENDIF
         Clear ClearAll
         Return true
      ENDIF
      Message.u(Window(),3,3)
   ENDWHILE
ENDPROC

WriteLib libname.a QueryByForm.l
Release PROCS QueryByForm.l
?? ""
; ===========================================================================
;       Title - Select.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - logical true or false
;  Chronology - Created: May, 1988     Last revised: 07/11/90 12:04pm
; Description - Generic item selection.  This is not a true WAIT handler.  I
;               normally use it to have the user select a Master record, and
;               then place user in detail table, so user does not need to
;               deal with image movement.
; ---------------------------------------------------------------------------
PROC Select.l(table.a,              ; table to select from
              form.a,               ; form to use
              insert.v,             ; Form to Insert Record if INSERT enabled
              skey.a,               ; Smartkey Parameters, or "0000" for none
              help.l,               ; is Help enabled
              prompt1.a,            ; prompt Line 1
              prompt2.a)            ; prompt Line 2
Private  uproc.a
;Global  select.r                   ; array to hold selected record, or "INSERT"
uproc.a = "Select.l"
   IF IsEmpty(table.a) THEN
      IF NOT insert.v = false THEN
         SelectAdd.l(table.a,insert.v)
         Return retval
      ELSE
         Return false
      ENDIF
   ENDIF

   View table.a
   PickForm form.a
   WHILE true
      WAIT Table Prompt
         prompt1.a,
         prompt2.a
      Until "Dos", "DosBig", "F35", "FieldView", "Zoom", "Ins", "Rotate",
            "ZoomNext", "Del", "F2", "Esc", "F1", -35

      SWITCH
         CASE retval = "Zoom":
            IF FieldNo(Field(),Table()) <= NKeyFields(Table()) THEN
               LocateArray.l()
            ELSE
               Zoom.l("FIRST")
            ENDIF
         CASE retval = "ZoomNext"   : Zoom.l("NEXT")
         CASE retval = "Esc" :
            Clear ClearAll
            Return false
         CASE retval = "Ins" :               ; can we add records?
            IF NOT insert.v = false THEN
               SelectAdd.l(table.a,insert.v,skey.a)
               IF NOT retval THEN
                  View table.a
                  PickForm form.a
                  LOOP
               ELSE
                  Message.u("W",0,0)
                  View table.a
                  PickForm form.a
                  Return true
               ENDIF
            ELSE
                  Beep
            ENDIF
         CASE retval = "F1"   : LookupHelpKey.u("Select")
         CASE retval = -35    : HelpMenu.u("Select")
         CASE retval = "F2"  :
            CopyToArray select.r            ; assign selected record to array
            Return true
         OTHERWISE           : Beep
      ENDSWITCH
   ENDWHILE
ENDPROC
WriteLib libname.a Select.l
Release PROCS Select.l
?? ""
; ===========================================================================
;       Title - SelectAdd.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - logical true or false
;  Chronology - Created: December, 1988     Last revised: 07/11/90 12:10pm
; Description - Generic Add a new Record to Selection table during Select
;               Does not use uproc.a convention
; ---------------------------------------------------------------------------
PROC SelectAdd.l(table.a,                 ; table to add record to
                 form.a,                  ; form to use
                 skey.a)                  ; Smarkey Parameter, or "0000"
Private uproc.a
   uproc.a = "SelectAdd.l"
   Message.u("Adding New Record to " +table.a+ " Table",0,0)
   PickForm form.a
   CoEditKey
   Ins
   WHILE true                                  ; loop til we droop
      IF skey.a <> "0000" THEN
         ImageRights UPDATE
      ENDIF
      WAIT Record Prompt                      ; add only one record
" Entering New Record into the " +table.a+ " Table...",
" Press [F2] to Save and Select this Record    [Esc] to Cancel this Record Add"
      Until "Dos", "DosBig", "F35", "FieldView", "Zoom", "Ins", "Rotate",
            "Del", "F2", "Esc", "F1", -35

      SWITCH
         CASE retval = "Esc" :                ; if [Esc], go back and start over
            DeleteRecord.l()
            IF retval THEN
               Do_It!
               ClearImage Return false
            ENDIF
         CASE retval = "F1"   : LookupHelpKey.u("Select")
         CASE retval = -35    : HelpMenu.u("Select")
         CASE retval = "F2"  :                 ; select the new record
            IF skey.a <> "0000" THEN
               SmartKey.l(NumVal(SubStr(skey.a,1,1)),NumVal(SubStr(skey.a,2,1)),
                          NumVal(SubStr(skey.a,3,1)),NumVal(SubStr(skey.a,4,1)))
               IF NOT retval THEN
                  LOOP
               ENDIF
            ENDIF
            CopyToArray select.r
            Message.u("Posting New Record to the " +table.a+ " Table",0,0)
            Do_It!
            Clear ClearAll Return true
         OTHERWISE           : Beep
      ENDSWITCH
   ENDWHILE
ENDPROC
WriteLib libname.a SelectAdd.l
Release PROCS SelectAdd.l
?? ""
; ===========================================================================
;       TITLE: SmartKey.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;              Based upon ideas by Steve Caple and David Kelton
;     CREATED: 02/19/91 01:33pm     LAST REVISED:
;     RETURNS: Logical true/false if successful
; DESCRIPTION: Generates a 4, 6 or 8 char smart ID Key based upon other fields
; ---------------------------------------------------------------------------
PROC SmartKey.l(size.n,field1.n,field2.n,field3.n)
Private uproc.a, r
   uproc.a = "SmartKey.l"
   ImageRights
   CopyToArray r
   SWITCH
      CASE field2.n = 0
       AND size.n = 4   :
         key.a = Upper(SubStr(StrVal(r[field1.n])+"####",1,2))
      CASE field2.n = 0
       AND size.n = 6   :
         key.a = Upper(SubStr(StrVal(r[field1.n])+"####",1,4))
      CASE field3.n = 0
       AND size.n = 6   :
         key.a = Upper(SubStr(StrVal(r[field1.n])+"####",1,2) +
                       SubStr(StrVal(r[field2.n])+"##",1,2))
      CASE field3.n = 0
       AND size.n = 8   :
         key.a = Upper(SubStr(StrVal(r[field1.n])+"####",1,4) +
                       SubStr(StrVal(r[field2.n])+"##",1,2))
      CASE field3.n > 0
       AND size.n = 8   :
         key.a = Upper(SubStr(StrVal(r[field1.n])+"###",1,3) +
                       SubStr(StrVal(r[field2.n])+"##",1,2) +
                       SubStr(StrVal(r[field3.n])+"#",1,1))
      OTHERWISE         :
         Message.u("Sorry, improper combination of size and fields!",-1,0)
         Return false
   ENDSWITCH

   n = 0
   WHILE true
      Message.u("Attempting to Post Record #" +StrVal(n)+ " for this Key",0,0)
      IF n > 99 THEN
         Message.u("There are already 100 Records with this Key!!!  Sorry",-1,0)
         Del
         Return false
      ENDIF

      IF n < 10 THEN
         r[2] = key.a +"0"+ StrVal(n)
      ELSE
         r[2] = key.a + StrVal(n)
      ENDIF

      CopyFromArray3.u("r", false)
      KeyLookup            ; Attempt toggle to possible offending key.
      error.n = ErrorCode()
      a = ErrorMessage()
      IF Match(a,"keylookup can not..") THEN
         ReSyncKey
         error.n = ErrorCode()
         ok.l = (error.n <> 53 AND error.n <> 3)
      ELSE
         ok.l = Error.n = 56
      ENDIF

      IF ok.l THEN         ; Lookupkey not found.
         LockRecord         ; Record posts, and cursor remains with it.
         Return true
      ELSE
         KeyLookup          ; Return to record values as operator entered.
      ENDIF
      n = n + 1
   ENDWHILE
ENDPROC
WriteLib libname.a   SmartKey.l
Release PROCS        SmartKey.l
?? ""
; ===========================================================================
;       Title - SplashForm.u
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No value
;  Chronology - Created: 08/14/90 11:40pm    Revised: 09/30/90 08:52pm
; Description - Generic Splash Screen using Table Form
; ---------------------------------------------------------------------------
PROC SplashForm.u()
Private uproc.a
;Global  cfgtable.a,                   ; Client reg table with splash form
;        form.n,                       ; 0=color  7=Mono
   uproc.a = "SplashForm.u"
   View cfgtable.a                     ; Put table on workspace
   PickForm (1 + form.n)               ; Display the splash form
   Canvas OFF                          ; Turn screen off while elves work
   Echo NORMAL                         ; These two echos place the workspace
   Echo OFF                            ;    on the canvas
   Canvas ON                           ; Turn on the lights, admire our work,
   IF color.l THEN
      PaintCanvas FILL "" ATTRIBUTE 112 0,0,1,79
   ELSE                                ; Fill top 2 lines (form doesn't reach)
      PaintCanvas FILL "" 0,0,1,79
   ENDIF
   Sleep 2000
   PopBox.u(8,"This Program Developed for " +[Company Name],0,SysColor(3),1)
   Return
ENDPROC
WriteLib libname.a SplashForm.u
Release PROCS SplashForm.u
?? ""
; ===========================================================================
;       Title - Startup.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;     Returns - No Value
;  Chronology - Created: 09/26/90 10:23:08pm    Revised:
; Description -
; ---------------------------------------------------------------------------
PROC Startup.l()
Private  uproc.a, n                    ; Available drivespace
;Global  swap.n,                       ; Passed SetSwap amount
;        cfgtable.a,                   ; Passed Name of Configuration Table
;        mem.n,                        ; Passed Original memleft
;        disk.n,                       ; Passed Necessary free drivespace
;        color.l,                      ; Set Color mode (color=true)
;        form.n                        ; Set Value to add to form numbers based
                                       ;   upon color mode (color=0  mono=7)
   uproc.a = "Startup.l"
   color.l = (Monitor() = "Color")
   IF color.l THEN                     ;   Forms 1-7=color  Forms 8-14=mono
      form.n = 0
   ELSE
      form.n = 7
   ENDIF

   SplashForm.u()                      ; Application code and form offset
   Release PROCS SplashForm.u          ; Don't need it anymore

   ; These next sections check for necessary environmental conditions
   IF Version() < 3 THEN                   ; Check version
      PopBox.u(1,"Sorry, you need Paradox 3 for this Program",2,SysColor(3),3)
      Return false
   ENDIF

   IF mem.n < 60000 THEN               ; Check for startup memory
      PopBox.u(1,"Memleft = " +StrVal(mem.n)+
               " - Not Enought to Start Program",2,SysColor(3),3)
      PopBox.u(12,"Try Unloading any TSR Programs to free Memory",2,SysColor(3),5)
      Return false
   ENDIF

   IF PrivDir() = "" THEN                  ; This checks for available drivespace
      IF DirExists("PRI") = 1 THEN
         SetPrivDir Directory()+"PRI"
      ELSE
         SetPrivDir Directory()
      ENDIF
   ENDIF
   n = DriveSpace(SubStr(PrivDir(),1,1))

   IF n < disk.n THEN
      PopBox.u(1,"Directory = " +StrVal(n)+ " bytes - " +StrVal(disk.n)+
              " bytes are Required to Start Program",2,SysColor(3),3)
      PopBox.u(12,"Try Deleting any Unnecessary Files to free Diskspace",2,
               SysColor(3),5)
      Return false
   ENDIF

   SWITCH
      CASE mem.n > 120000 : swap.n = 60000
      CASE mem.n < 70000  : swap.n = 35000
      OTHERWISE           : swap.n = Int(mem.n/2)
   ENDSWITCH
   IF mem.n < 100000 THEN
      SetSwap Int(swap.n/2)
   ELSE
      SetSwap swap.n
   ENDIF
   SetRetryPeriod 60
   SetRestartCount 30
   IF IsFile(PrivDir()+"Username.sc") THEN
      Play "UserName"                     ; Sets Username from Enviornment
   ENDIF
   Return true
ENDPROC
WriteLib libname.a Startup.l
Release PROCS Startup.l
?? ""
; ===========================================================================
;       Title - Zoom.l
;      AUTHOR: (c) 1991 - Daniel J. Paolini II, CMA - dp Solutions, Inc.
;               Based upon a procedure by Alan Zenreich
;     Returns - Logical true/false if match located
;  Chronology - Created: 11/11/90 11:50:26pm    Revised:
; Description -
; ---------------------------------------------------------------------------
PROC Zoom.l(type.a)
Private uproc.a, l,              ; Logical true/false if match found
        n,              ; Used by GETCHAR().
        window.a,       ; Message returned by Window()
        fieldview.l     ; Keeps track of fieldview status while in zoom prompt.
   uproc.a = "Zoom.l"
   IF NImageRecords() < 2 or ColNo() = 1 THEN
      Message.u("Sorry, you cannot Search in RecNo Field, or in 1-record Table",3,1)
      Return false                   ; Can't Zoom under these conditions
   ENDIF

   IF Upper(type.a) = "NEXT" THEN
      Message.u("Searching for Next Value",0,0)
      ZoomNext
      window.a = Window()
      l = IsBlank(window.a)
   ELSE
      Echo NORMAL
      Zoom
      CtrlBackSpace                           ; erase previous value
      fieldview.l = false
      WHILE true
         n = GetChar()      ; Wait for operator's keypress.
         SWITCH
            CASE  n = -108
              OR n = 6      :       ; [Alt+F5] fieldview or [Ctrl+F].
                  KeyPress n                    ; Press the key.
                  fieldview.l = NOT fieldview.l ; Fieldview is started/finished.
            CASE n = -71
              OR n = -75
              OR n = -77
              OR n = -79
              OR n = -82
              OR n = -83    :
               KeyPress n
            CASE n < 0
              OR n = 15     :               ; Includes unwanted function keys & ^O.
               Beep                        ; Beep on error.
            CASE fieldview.l
             AND n = 13     :               ; User pressed [Enter] while in fieldview.
               Enter                       ; End field view.
               fieldview.l = False
            CASE n = 13     :               ; User pressed [Enter].
               KeyPress n                  ; Press the key as if the user typed it.
               window.a = Window()
               l = IsBlank(window.a)
               QUITLOOP
            CASE n = 27     :               ; Pressed [Esc].
               Esc                         ; Get out of zoom with Esc.
               window.a = "Zoom Canceled"
               Echo OFF
               l = false                   ; With RETVAL now set to False instead
   ; of "Esc", the "Esc" does not activate a previous WAIT's UNTIL condition.
               QUITLOOP
            OTHERWISE       :               ; Any legitimate key.
               KeyPress n                  ; Press the user's key.
         ENDSWITCH
      ENDWHILE
   ENDIF

   IF l THEN
      HilightRecord.u()
      Message.u("The Value was Located",1,2)
   ELSE
      IF window.a = "Zoom Canceled" THEN
         Message.u(window.a,1,2)
      ELSE
         Message.u(window.a+ " - Is caSE Correct?",3,2)
      ENDIF
   ENDIF

   Echo OFF
   Return l
ENDPROC
WriteLib libname.a Zoom.l
Release PROCS      Zoom.l
?? ""
